# 设计模式

### 资源列表
- [domnikl/DesignPatternsPHP](https://github.com/domnikl/DesignPatternsPHP)
- [TIGERB/easy-tips](https://github.com/TIGERB/easy-tips)
- [hoohack/DesignPattern](https://github.com/hoohack/DesignPattern)

### 六大原则
- 单一职责原则：`即一个类只负责一项职责`
- 里氏替换原则：`超类（父类）出现的地方，派生类（子类）都可以出现`
- 依赖倒置原则：`抽象不应该依赖细节；细节应该依赖抽象`
- 接口隔离原则: `使用多个接口，而不是对一个接口编程，去依赖降低耦合`
- 迪米特法则：`一个对象应该对其他对象保持最少的了解`
- 开闭原则：`对扩展开放，对修改关闭`

> **`总结: 核心：高内聚松耦合（单一职责），外部依赖，实体对抽象编程，抽象就是分层`**

### 模式类型
- 创建型
    - [AbstractFactory（抽象工厂）](AbstractFactory/)
    - [构建器模式](Build/)
    - [工厂方法模式](FactoryMethod/)
    - [多例模式](Multiton/)
    - [资源池模式](Pool/)
    - 原型模式
    - 简单工厂模式
    - 单例模式
- 结构型
    - 桥接模式
    - 享元模式
    - 外观模式
    - 适配器模式
    - 装饰器模式
    - 组合模式
    - 代理模式
    - 过滤器模式
- 行为型
    - 模板模式
    - 策略模式
    - 状态模式
    - 观察者模式
    - 责任链模式
    - 访问者模式
    - 解释器模式
    - 备忘录模式
    - 命令模式
    - 迭代器模式
    - 中介者器模式
    - 空对象模式
